- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::Vector Class Reference

Vector Base Class. More...

`#include <IpVector.hpp>`

Inheritance diagram for Ipopt::Vector:

[legend]
Collaboration diagram for Ipopt::Vector:

[legend]
List of all members.

## Public Member Functions
Vector * | MakeNew () const
| Create new Vector of the same type with uninitialized data.
Vector * | MakeNewCopy () const
| Create new Vector of the same type and copy the data over.
bool | HasValidNumbers () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan).
Constructor/Destructor
| Vector (const VectorSpace *owner_space)
| Constructor.
virtual | ~Vector ()
| Destructor.
Standard BLAS-1 Operations
(derived classes do NOT overload these methods, instead, overload the protected versions of these methods).
void | Copy (const Vector &x)
| Copy the data of the vector x into this vector (DCOPY).
void | Scal (Number alpha)
| Scales the vector by scalar alpha (DSCAL).
void | Axpy (Number alpha, const Vector &x)
| Add the multiple alpha of vector x to this vector (DAXPY).
Number | Dot (const Vector &x) const
| Computes inner product of vector x with this (DDOT).
Number | Nrm2 () const
| Computes the 2-norm of this vector (DNRM2).
Number | Asum () const
| Computes the 1-norm of this vector (DASUM).
Number | Amax () const
| Computes the max-norm of this vector (based on IDAMAX).
Additional (Non-BLAS) Vector Methods
(derived classes do NOT overload these methods, instead, overload the protected versions of these methods).
void | Set (Number alpha)
| Set each element in the vector to the scalar alpha.
void | ElementWiseDivide (const Vector &x)
| Element-wise division .
void | ElementWiseMultiply (const Vector &x)
| Element-wise multiplication .
void | ElementWiseMax (const Vector &x)
| Element-wise max against entries in x.
void | ElementWiseMin (const Vector &x)
| Element-wise min against entries in x.
void | ElementWiseReciprocal ()
| Reciprocates the entries in the vector.
void | ElementWiseAbs ()
| Absolute values of the entries in the vector.
void | ElementWiseSqrt ()
| Element-wise square root of the entries in the vector.
void | ElementWiseSgn ()
| Replaces the vector values with their sgn values ( -1 if x_i < 0, 0 if x_i == 0, and 1 if x_i > 0).
void | AddScalar (Number scalar)
| Add scalar to every vector component.
Number | Max () const
| Returns the maximum value in the vector.
Number | Min () const
| Returns the minimum value in the vector.
Number | Sum () const
| Returns the sum of the vector entries.
Number | SumLogs () const
| Returns the sum of the logs of each vector entry.
Methods for specialized operations. A prototype
implementation is provided, but for efficient implementation those should be specially implemented.
void | AddOneVector (Number a, const Vector &v1, Number c)
| Add one vector, y = a * v1 + c * y.
void | AddTwoVectors (Number a, const Vector &v1, Number b, const Vector &v2, Number c)
| Add two vectors, y = a * v1 + b * v2 + c * y.
Number | FracToBound (const Vector &delta, Number tau) const
| Fraction to the boundary parameter.
void | AddVectorQuotient (Number a, const Vector &z, const Vector &s, Number c)
| Add the quotient of two vectors, y = a * z/s + c * y.
Accessor methods
Index | Dim () const
| Dimension of the Vector.
SmartPtr< const VectorSpace > | OwnerSpace () const
| Return the owner VectorSpace.
Output methods
(derived classes do NOT overload these methods, instead, overload the protected versions of these methods).
void | Print (SmartPtr< const Journalist > jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
| Print the entire vector.
void | Print (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
| Print the entire vector.
## Protected Member Functions
implementation methods (derived classes MUST
overload these pure virtual protected methods.)
virtual void | CopyImpl (const Vector &x)=0
| Copy the data of the vector x into this vector (DCOPY).
virtual void | ScalImpl (Number alpha)=0
| Scales the vector by scalar alpha (DSCAL).
virtual void | AxpyImpl (Number alpha, const Vector &x)=0
| Add the multiple alpha of vector x to this vector (DAXPY).
virtual Number | DotImpl (const Vector &x) const =0
| Computes inner product of vector x with this (DDOT).
virtual Number | Nrm2Impl () const =0
| Computes the 2-norm of this vector (DNRM2).
virtual Number | AsumImpl () const =0
| Computes the 1-norm of this vector (DASUM).
virtual Number | AmaxImpl () const =0
| Computes the max-norm of this vector (based on IDAMAX).
virtual void | SetImpl (Number alpha)=0
| Set each element in the vector to the scalar alpha.
virtual void | ElementWiseDivideImpl (const Vector &x)=0
| Element-wise division .
virtual void | ElementWiseMultiplyImpl (const Vector &x)=0
| Element-wise multiplication .
virtual void | ElementWiseMaxImpl (const Vector &x)=0
| Element-wise max against entries in x.
virtual void | ElementWiseMinImpl (const Vector &x)=0
| Element-wise min against entries in x.
virtual void | ElementWiseReciprocalImpl ()=0
| Reciprocates the elements of the vector.
virtual void | ElementWiseAbsImpl ()=0
| Take elementwise absolute values of the elements of the vector.
virtual void | ElementWiseSqrtImpl ()=0
| Take elementwise square-root of the elements of the vector.
virtual void | ElementWiseSgnImpl ()=0
| Replaces entries with sgn of the entry.
virtual void | AddScalarImpl (Number scalar)=0
| Add scalar to every component of vector.
virtual Number | MaxImpl () const =0
| Max value in the vector.
virtual Number | MinImpl () const =0
| Min number in the vector.
virtual Number | SumImpl () const =0
| Sum of entries in the vector.
virtual Number | SumLogsImpl () const =0
| Sum of logs of entries in the vector.
virtual void | AddTwoVectorsImpl (Number a, const Vector &v1, Number b, const Vector &v2, Number c)
| Add two vectors (a * v1 + b * v2).
virtual Number | FracToBoundImpl (const Vector &delta, Number tau) const
| Fraction to boundary parameter.
virtual void | AddVectorQuotientImpl (Number a, const Vector &z, const Vector &s, Number c)
| Add the quotient of two vectors.
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan).
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const =0
| Print the entire vector.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| Vector ()
| Default constructor.
| Vector (const Vector &)
| Copy constructor.
Vector & | operator= (const Vector &)
| Overloaded Equals Operator.
## Private Attributes
const SmartPtr< const VectorSpace > | owner_space_
| Vector Space.
CachedResults data members
CachedResults< Number > | dot_cache_
| Cache for dot products.
TaggedObject::Tag | nrm2_cache_tag_
| Cache for dot products.
Number | cached_nrm2_
| Cache for dot products.
TaggedObject::Tag | asum_cache_tag_
| Cache for dot products.
Number | cached_asum_
| Cache for dot products.
TaggedObject::Tag | amax_cache_tag_
| Cache for dot products.
Number | cached_amax_
| Cache for dot products.
TaggedObject::Tag | max_cache_tag_
| Cache for dot products.
Number | cached_max_
| Cache for dot products.
TaggedObject::Tag | min_cache_tag_
| Cache for dot products.
Number | cached_min_
| Cache for dot products.
TaggedObject::Tag | sum_cache_tag_
| Cache for dot products.
Number | cached_sum_
| Cache for dot products.
TaggedObject::Tag | sumlogs_cache_tag_
| Cache for dot products.
Number | cached_sumlogs_
| Cache for dot products.
TaggedObject::Tag | valid_cache_tag_
| Cache for dot products.
bool | cached_valid_
| Cache for dot products.

## Detailed Description

Vector Base Class.

This is the base class for all derived vector types. Those vectors are meant to store entities like iterates, Lagrangian multipliers, constraint values etc. The implementation of a vector type depends on the computational environment (e.g. just a double array on a shared memory machine, or distributed double arrays for a distributed memory machine.)

Deriving from Vector: This class inherits from tagged object to implement an advanced caching scheme. Because of this, the TaggedObject method ObjectChanged() must be called each time the Vector changes. If you overload the XXXX_Impl protected methods, this taken care of (along with caching if possible) for you. If you have additional methods in your derived class that change the underlying data (vector values), you MUST remember to call ObjectChanged() AFTER making the change!

Definition at line 47 of file IpVector.hpp.

## Constructor & Destructor Documentation

Ipopt::Vector::Vector | ( | const VectorSpace * | owner_space | ) | `[inline]`

Constructor.

It has to be given a pointer to the corresponding VectorSpace.

Definition at line 415 of file IpVector.hpp.

References DBG_ASSERT, Ipopt::IsValid(), and owner_space_.

Ipopt::Vector::~Vector | ( |  | ) | `[inline, virtual]`

Destructor.

Definition at line 411 of file IpVector.hpp.

Ipopt::Vector::Vector | ( |  | ) | `[private]`

Default constructor.

Ipopt::Vector::Vector | ( | const Vector & |  | ) | `[private]`

Copy constructor.

## Member Function Documentation

Vector * Ipopt::Vector::MakeNew | ( |  | ) | const`[inline]`

Create new Vector of the same type with uninitialized data.

Definition at line 433 of file IpVector.hpp.

References owner_space_.

Referenced by MakeNewCopy().

Vector * Ipopt::Vector::MakeNewCopy | ( |  | ) | const`[inline]`

Create new Vector of the same type and copy the data over.

Definition at line 439 of file IpVector.hpp.

References Copy(), and MakeNew().

void Ipopt::Vector::Copy | ( | const Vector & | x | ) | `[inline]`

Copy the data of the vector x into this vector (DCOPY).

Definition at line 448 of file IpVector.hpp.

References amax_cache_tag_, asum_cache_tag_, cached_amax_, cached_asum_, cached_max_, cached_min_, cached_nrm2_, cached_sum_, cached_sumlogs_, CopyImpl(), Ipopt::TaggedObject::GetTag(), max_cache_tag_, min_cache_tag_, nrm2_cache_tag_, Ipopt::TaggedObject::ObjectChanged(), sum_cache_tag_, and sumlogs_cache_tag_.

Referenced by MakeNewCopy().

void Ipopt::Vector::Scal | ( | Number | alpha | ) |

Scales the vector by scalar alpha (DSCAL).

void Ipopt::Vector::Axpy | ( | Number | alpha,
|  | const Vector & | x |
| ) |  |  | `[inline]`

Add the multiple alpha of vector x to this vector (DAXPY).

Definition at line 486 of file IpVector.hpp.

References AxpyImpl(), and Ipopt::TaggedObject::ObjectChanged().

Number Ipopt::Vector::Dot | ( | const Vector & | x | ) | const`[inline]`

Computes inner product of vector x with this (DDOT).

Definition at line 493 of file IpVector.hpp.

References dot_cache_, DotImpl(), and Nrm2().

Number Ipopt::Vector::Nrm2 | ( |  | ) | const`[inline]`

Computes the 2-norm of this vector (DNRM2).

Definition at line 512 of file IpVector.hpp.

References cached_nrm2_, Ipopt::TaggedObject::GetTag(), nrm2_cache_tag_, and Nrm2Impl().

Referenced by Dot().

Number Ipopt::Vector::Asum | ( |  | ) | const`[inline]`

Computes the 1-norm of this vector (DASUM).

Definition at line 522 of file IpVector.hpp.

References asum_cache_tag_, AsumImpl(), cached_asum_, and Ipopt::TaggedObject::GetTag().

Number Ipopt::Vector::Amax | ( |  | ) | const`[inline]`

Computes the max-norm of this vector (based on IDAMAX).

Definition at line 532 of file IpVector.hpp.

References amax_cache_tag_, AmaxImpl(), cached_amax_, and Ipopt::TaggedObject::GetTag().

void Ipopt::Vector::Set | ( | Number | alpha | ) | `[inline]`

Set each element in the vector to the scalar alpha.

Definition at line 569 of file IpVector.hpp.

References Ipopt::TaggedObject::ObjectChanged(), and SetImpl().

Referenced by Ipopt::Matrix::ComputeColAMax(), and Ipopt::Matrix::ComputeRowAMax().

void Ipopt::Vector::ElementWiseDivide | ( | const Vector & | x | ) | `[inline]`

Element-wise division .

Definition at line 577 of file IpVector.hpp.

References ElementWiseDivideImpl(), and Ipopt::TaggedObject::ObjectChanged().

void Ipopt::Vector::ElementWiseMultiply | ( | const Vector & | x | ) | `[inline]`

Element-wise multiplication .

Definition at line 584 of file IpVector.hpp.

References ElementWiseMultiplyImpl(), and Ipopt::TaggedObject::ObjectChanged().

void Ipopt::Vector::ElementWiseMax | ( | const Vector & | x | ) | `[inline]`

Element-wise max against entries in x.

Definition at line 598 of file IpVector.hpp.

References ElementWiseMaxImpl(), and Ipopt::TaggedObject::ObjectChanged().

void Ipopt::Vector::ElementWiseMin | ( | const Vector & | x | ) | `[inline]`

Element-wise min against entries in x.

Definition at line 606 of file IpVector.hpp.

References ElementWiseMinImpl(), and Ipopt::TaggedObject::ObjectChanged().

void Ipopt::Vector::ElementWiseReciprocal | ( |  | ) | `[inline]`

Reciprocates the entries in the vector.

Definition at line 591 of file IpVector.hpp.

References ElementWiseReciprocalImpl(), and Ipopt::TaggedObject::ObjectChanged().

void Ipopt::Vector::ElementWiseAbs | ( |  | ) | `[inline]`

Absolute values of the entries in the vector.

Definition at line 614 of file IpVector.hpp.

References ElementWiseAbsImpl(), and Ipopt::TaggedObject::ObjectChanged().

void Ipopt::Vector::ElementWiseSqrt | ( |  | ) | `[inline]`

Element-wise square root of the entries in the vector.

Definition at line 622 of file IpVector.hpp.

References ElementWiseSqrtImpl(), and Ipopt::TaggedObject::ObjectChanged().

void Ipopt::Vector::ElementWiseSgn | ( |  | ) | `[inline]`

Replaces the vector values with their sgn values ( -1 if x_i < 0, 0 if x_i == 0, and 1 if x_i > 0).

Definition at line 562 of file IpVector.hpp.

References ElementWiseSgnImpl(), and Ipopt::TaggedObject::ObjectChanged().

void Ipopt::Vector::AddScalar | ( | Number | scalar | ) | `[inline]`

Add scalar to every vector component.

Definition at line 629 of file IpVector.hpp.

References AddScalarImpl(), and Ipopt::TaggedObject::ObjectChanged().

Number Ipopt::Vector::Max | ( |  | ) | const`[inline]`

Returns the maximum value in the vector.

Definition at line 637 of file IpVector.hpp.

References cached_max_, Ipopt::TaggedObject::GetTag(), max_cache_tag_, and MaxImpl().

Number Ipopt::Vector::Min | ( |  | ) | const`[inline]`

Returns the minimum value in the vector.

Definition at line 647 of file IpVector.hpp.

References cached_min_, Ipopt::TaggedObject::GetTag(), min_cache_tag_, and MinImpl().

Number Ipopt::Vector::Sum | ( |  | ) | const`[inline]`

Returns the sum of the vector entries.

Definition at line 542 of file IpVector.hpp.

References cached_sum_, Ipopt::TaggedObject::GetTag(), sum_cache_tag_, and SumImpl().

Number Ipopt::Vector::SumLogs | ( |  | ) | const`[inline]`

Returns the sum of the logs of each vector entry.

Definition at line 552 of file IpVector.hpp.

References cached_sumlogs_, Ipopt::TaggedObject::GetTag(), sumlogs_cache_tag_, and SumLogsImpl().

void Ipopt::Vector::AddOneVector | ( | Number | a,
|  | const Vector & | v1,
|  | Number | c |
| ) |  |  | `[inline]`

Add one vector, y = a * v1 + c * y.

This is automatically reduced to call AddTwoVectors.

Definition at line 657 of file IpVector.hpp.

References AddTwoVectors().

void Ipopt::Vector::AddTwoVectors | ( | Number | a,
|  | const Vector & | v1,
|  | Number | b,
|  | const Vector & | v2,
|  | Number | c |
| ) |  |  | `[inline]`

Add two vectors, y = a * v1 + b * v2 + c * y.

Here, this vector is y

Definition at line 663 of file IpVector.hpp.

References AddTwoVectorsImpl(), and Ipopt::TaggedObject::ObjectChanged().

Referenced by AddOneVector().

Number Ipopt::Vector::FracToBound | ( | const Vector & | delta,
|  | Number | tau |
| ) |  |  | const`[inline]`

Fraction to the boundary parameter.

Computes

Definition at line 671 of file IpVector.hpp.

References FracToBoundImpl().

void Ipopt::Vector::AddVectorQuotient | ( | Number | a,
|  | const Vector & | z,
|  | const Vector & | s,
|  | Number | c |
| ) |  |  | `[inline]`

Add the quotient of two vectors, y = a * z/s + c * y.

Definition at line 691 of file IpVector.hpp.

References AddVectorQuotientImpl(), and Ipopt::TaggedObject::ObjectChanged().

bool Ipopt::Vector::HasValidNumbers | ( |  | ) | const`[inline]`

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Definition at line 699 of file IpVector.hpp.

References cached_valid_, Ipopt::TaggedObject::GetTag(), HasValidNumbersImpl(), and valid_cache_tag_.

Index Ipopt::Vector::Dim | ( |  | ) | const`[inline]`

Dimension of the Vector.

Definition at line 709 of file IpVector.hpp.

References owner_space_.

Referenced by Ipopt::Matrix::ComputeColAMax(), Ipopt::Matrix::ComputeRowAMax(), and Ipopt::DenseVector::Values().

SmartPtr< const VectorSpace > Ipopt::Vector::OwnerSpace | ( |  | ) | const`[inline]`

Return the owner VectorSpace.

Definition at line 715 of file IpVector.hpp.

References owner_space_.

void Ipopt::Vector::Print | ( | SmartPtr< const Journalist > | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent = `0`,
|  | const std::string & | prefix = `""` |
| ) |  |  | const

Print the entire vector.

void Ipopt::Vector::Print | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent = `0`,
|  | const std::string & | prefix = `""` |
| ) |  |  | const

Print the entire vector.

virtual void Ipopt::Vector::CopyImpl | ( | const Vector & | x | ) | `[protected, pure virtual]`

Copy the data of the vector x into this vector (DCOPY).

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by Copy().

virtual void Ipopt::Vector::ScalImpl | ( | Number | alpha | ) | `[protected, pure virtual]`

Scales the vector by scalar alpha (DSCAL).

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

virtual void Ipopt::Vector::AxpyImpl | ( | Number | alpha,
|  | const Vector & | x |
| ) |  |  | `[protected, pure virtual]`

Add the multiple alpha of vector x to this vector (DAXPY).

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by Axpy().

virtual Number Ipopt::Vector::DotImpl | ( | const Vector & | x | ) | const`[protected, pure virtual]`

Computes inner product of vector x with this (DDOT).

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by Dot().

virtual Number Ipopt::Vector::Nrm2Impl | ( |  | ) | const`[protected, pure virtual]`

Computes the 2-norm of this vector (DNRM2).

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by Nrm2().

virtual Number Ipopt::Vector::AsumImpl | ( |  | ) | const`[protected, pure virtual]`

Computes the 1-norm of this vector (DASUM).

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by Asum().

virtual Number Ipopt::Vector::AmaxImpl | ( |  | ) | const`[protected, pure virtual]`

Computes the max-norm of this vector (based on IDAMAX).

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by Amax().

virtual void Ipopt::Vector::SetImpl | ( | Number | alpha | ) | `[protected, pure virtual]`

Set each element in the vector to the scalar alpha.

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by Set().

virtual void Ipopt::Vector::ElementWiseDivideImpl | ( | const Vector & | x | ) | `[protected, pure virtual]`

Element-wise division .

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by ElementWiseDivide().

virtual void Ipopt::Vector::ElementWiseMultiplyImpl | ( | const Vector & | x | ) | `[protected, pure virtual]`

Element-wise multiplication .

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by ElementWiseMultiply().

virtual void Ipopt::Vector::ElementWiseMaxImpl | ( | const Vector & | x | ) | `[protected, pure virtual]`

Element-wise max against entries in x.

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by ElementWiseMax().

virtual void Ipopt::Vector::ElementWiseMinImpl | ( | const Vector & | x | ) | `[protected, pure virtual]`

Element-wise min against entries in x.

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by ElementWiseMin().

virtual void Ipopt::Vector::ElementWiseReciprocalImpl | ( |  | ) | `[protected, pure virtual]`

Reciprocates the elements of the vector.

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by ElementWiseReciprocal().

virtual void Ipopt::Vector::ElementWiseAbsImpl | ( |  | ) | `[protected, pure virtual]`

Take elementwise absolute values of the elements of the vector.

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by ElementWiseAbs().

virtual void Ipopt::Vector::ElementWiseSqrtImpl | ( |  | ) | `[protected, pure virtual]`

Take elementwise square-root of the elements of the vector.

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by ElementWiseSqrt().

virtual void Ipopt::Vector::ElementWiseSgnImpl | ( |  | ) | `[protected, pure virtual]`

Replaces entries with sgn of the entry.

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by ElementWiseSgn().

virtual void Ipopt::Vector::AddScalarImpl | ( | Number | scalar | ) | `[protected, pure virtual]`

Add scalar to every component of vector.

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by AddScalar().

virtual Number Ipopt::Vector::MaxImpl | ( |  | ) | const`[protected, pure virtual]`

Max value in the vector.

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by Max().

virtual Number Ipopt::Vector::MinImpl | ( |  | ) | const`[protected, pure virtual]`

Min number in the vector.

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by Min().

virtual Number Ipopt::Vector::SumImpl | ( |  | ) | const`[protected, pure virtual]`

Sum of entries in the vector.

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by Sum().

virtual Number Ipopt::Vector::SumLogsImpl | ( |  | ) | const`[protected, pure virtual]`

Sum of logs of entries in the vector.

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by SumLogs().

virtual void Ipopt::Vector::AddTwoVectorsImpl | ( | Number | a,
|  | const Vector & | v1,
|  | Number | b,
|  | const Vector & | v2,
|  | Number | c |
| ) |  |  | `[protected, virtual]`

Add two vectors (a * v1 + b * v2).

Result is stored in this vector.

Reimplemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by AddTwoVectors().

virtual Number Ipopt::Vector::FracToBoundImpl | ( | const Vector & | delta,
|  | Number | tau |
| ) |  |  | const`[protected, virtual]`

Fraction to boundary parameter.

Reimplemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by FracToBound().

virtual void Ipopt::Vector::AddVectorQuotientImpl | ( | Number | a,
|  | const Vector & | z,
|  | const Vector & | s,
|  | Number | c |
| ) |  |  | `[protected, virtual]`

Add the quotient of two vectors.

Reimplemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Referenced by AddVectorQuotient().

virtual bool Ipopt::Vector::HasValidNumbersImpl | ( |  | ) | const`[protected, virtual]`

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

A default implementation using Asum is provided.

Reimplemented in Ipopt::CompoundVector.

Referenced by HasValidNumbers().

virtual void Ipopt::Vector::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix |
| ) |  |  | const`[protected, pure virtual]`

Print the entire vector.

Implemented in Ipopt::CompoundVector, and Ipopt::DenseVector.

Vector& Ipopt::Vector::operator= | ( | const Vector & |  | ) | `[private]`

Overloaded Equals Operator.

## Member Data Documentation

const SmartPtr<const VectorSpace> Ipopt::Vector::owner_space_`[private]`

Vector Space.

Reimplemented in Ipopt::IteratesVector, Ipopt::CompoundVector, and Ipopt::DenseVector.

Definition at line 313 of file IpVector.hpp.

Referenced by Dim(), MakeNew(), OwnerSpace(), and Vector().

CachedResults<Number> Ipopt::Vector::dot_cache_`[mutable, private]`

Cache for dot products.

Definition at line 318 of file IpVector.hpp.

Referenced by Dot().

TaggedObject::Tag Ipopt::Vector::nrm2_cache_tag_`[mutable, private]`

Cache for dot products.

Definition at line 320 of file IpVector.hpp.

Referenced by Copy(), and Nrm2().

Number Ipopt::Vector::cached_nrm2_`[mutable, private]`

Cache for dot products.

Definition at line 321 of file IpVector.hpp.

Referenced by Copy(), and Nrm2().

TaggedObject::Tag Ipopt::Vector::asum_cache_tag_`[mutable, private]`

Cache for dot products.

Definition at line 323 of file IpVector.hpp.

Referenced by Asum(), and Copy().

Number Ipopt::Vector::cached_asum_`[mutable, private]`

Cache for dot products.

Definition at line 324 of file IpVector.hpp.

Referenced by Asum(), and Copy().

TaggedObject::Tag Ipopt::Vector::amax_cache_tag_`[mutable, private]`

Cache for dot products.

Definition at line 326 of file IpVector.hpp.

Referenced by Amax(), and Copy().

Number Ipopt::Vector::cached_amax_`[mutable, private]`

Cache for dot products.

Definition at line 327 of file IpVector.hpp.

Referenced by Amax(), and Copy().

TaggedObject::Tag Ipopt::Vector::max_cache_tag_`[mutable, private]`

Cache for dot products.

Definition at line 329 of file IpVector.hpp.

Referenced by Copy(), and Max().

Number Ipopt::Vector::cached_max_`[mutable, private]`

Cache for dot products.

Definition at line 330 of file IpVector.hpp.

Referenced by Copy(), and Max().

TaggedObject::Tag Ipopt::Vector::min_cache_tag_`[mutable, private]`

Cache for dot products.

Definition at line 332 of file IpVector.hpp.

Referenced by Copy(), and Min().

Number Ipopt::Vector::cached_min_`[mutable, private]`

Cache for dot products.

Definition at line 333 of file IpVector.hpp.

Referenced by Copy(), and Min().

TaggedObject::Tag Ipopt::Vector::sum_cache_tag_`[mutable, private]`

Cache for dot products.

Definition at line 335 of file IpVector.hpp.

Referenced by Copy(), and Sum().

Number Ipopt::Vector::cached_sum_`[mutable, private]`

Cache for dot products.

Definition at line 336 of file IpVector.hpp.

Referenced by Copy(), and Sum().

TaggedObject::Tag Ipopt::Vector::sumlogs_cache_tag_`[mutable, private]`

Cache for dot products.

Definition at line 338 of file IpVector.hpp.

Referenced by Copy(), and SumLogs().

Number Ipopt::Vector::cached_sumlogs_`[mutable, private]`

Cache for dot products.

Definition at line 339 of file IpVector.hpp.

Referenced by Copy(), and SumLogs().

TaggedObject::Tag Ipopt::Vector::valid_cache_tag_`[mutable, private]`

Cache for dot products.

Definition at line 341 of file IpVector.hpp.

Referenced by HasValidNumbers().

bool Ipopt::Vector::cached_valid_`[mutable, private]`

Cache for dot products.

Definition at line 342 of file IpVector.hpp.

Referenced by HasValidNumbers().

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.7.1/Ipopt/src/LinAlg/IpVector.hpp